Subject: Re: bug#23648: [PATCH] `defun-declarations-alist' can be unintentionally modified

From: Noam Postavsky <[email-masked]>
Date: Mon, 18 Jul 2016 14:58:20 -0400

On Mon, Jul 18, 2016 at 2:16 PM, Eli Zaretskii <[email-masked]> wrote:
>> From: Noam Postavsky <[email-masked]>
>> Date: Mon, 18 Jul 2016 11:53:42 -0400
>> Cc: Paul Pogonyshev <[email-masked]>, [email-masked]
>>
>> > I'm not sure, actually.  How probable is the situation where this
>> > problem pops up?
>>
>> It happens with 100% probability when performing completion inside a
>> (declare ...) form. Starting from emacs -Q, put into *scratch*
>>
>> (defun foo ()
>>   (declare (indent 1))
>>   nil)
>>
>> Macroexpanding this gives:
>>
>> (prog1
>>     (defalias 'foo
>>       #'(lambda nil nil))
>>   (put 'foo 'lisp-indent-function '1))
>>
>> Now move point to just after "indent" and type C-M-i (this gives
>> message "Sole completion"), macroexpanding now gives
>>
>> (prog1
>>     (defalias 'foo
>>       #'(lambda nil nil))
>>   "Warning: Unknown defun property `indent' in foo")
>
> Sorry, I'm not following: what do you mean by "macroexpanding" in this
> context?

Calling macroexpand on the defun form. The most convenient method for
testing is to put point at the closing bracket of the defun, and then
`M-x pp-macroexpand-last-sexp'.

> When you wrote "when performing completion", I expected to
> see some simple completion gesture that leads to an error, but it
> sounds like I'm missing something.

The simple completion gesture would be the C-M-i I mentioned, which
(silently) destroys the value of defun-declarations-alist. The
symptoms of the wrong value can be seen when defun is macroexpanded.